
import 'package:flutter/foundation.dart';
import 'package:flutter_conscent_plugin/Model/APIMode.dart';

import 'ConscentMethods.dart';

class ConscentInitializer {
  String? clientId;
  static String? mClientId;
  MODE? apiMode;
  static String? mContentId;

  ConscentInitializer(String this.clientId, MODE this.apiMode) {
    if (clientId == null) {
      ConscentMethods()
          .onPluginError("Client ID is invalid, please check again");
    }
    print("ConscentInitializer ${clientId} ${apiMode}");

    mClientId = clientId;

    APIMode.getConscentServiceUrl(apiMode!);

    print(APIMode.BASE_URL);
  }

  static setContentId(String contentId) {
    if (contentId.isEmpty) {
      ConscentMethods()
          .onPluginError("Content ID is invalid, please check again");
    }
    print('contentId ${contentId}');
    mContentId = contentId;
  }

  static String? getContentId(String contentId) {
    print('contentId $contentId');
    return mContentId;
  }

  static setClientId(String clientId) {
    if (kDebugMode) {
      print('ClientId $clientId');
    }
    mClientId = clientId;
  }
}
