
class PaywallViewEvent {
  String? topic;
  List<MessageBody>? messageBody;

  PaywallViewEvent({this.topic, this.messageBody});

  PaywallViewEvent.fromJson(Map<String, dynamic> json) {
    topic = json['topic'];
    if (json['messageBody'] != null) {
      messageBody = <MessageBody>[];
      json['messageBody'].forEach((v) {
        messageBody!.add(new MessageBody.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['topic'] = this.topic;
    if (this.messageBody != null) {
      data['messageBody'] = this.messageBody!.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class MessageBody {
  String? anonId;
  String? browser;
  String? browserVersion;
  String? clientId;
  String? contentId;
  String? createdAt;
  String? deviceType;
  String? eventLocation;
  String? eventType;
  String? id;
  int? isCookieBlocked;
  String? mobileModel;
  int? numOfCta;
  String? osName;
  String? osVersion;
  String? paywallDisplayType;
  String? paywallId;
  String? paywallType;
  String? updatedAt;
  String? url;
  String? userAgent;
  String? userSourceData;

  MessageBody(
      {this.anonId,
      this.browser,
      this.browserVersion,
      this.clientId,
      this.contentId,
      this.createdAt,
      this.deviceType,
      this.eventLocation,
      this.eventType,
      this.id,
      this.isCookieBlocked,
      this.mobileModel,
      this.numOfCta,
      this.osName,
      this.osVersion,
      this.paywallDisplayType,
      this.paywallId,
      this.paywallType,
      this.updatedAt,
      this.url,
      this.userAgent,
      this.userSourceData});

  MessageBody.fromJson(Map<String, dynamic> json) {
    anonId = json['anonId'];
    browser = json['browser'];
    browserVersion = json['browserVersion'];
    clientId = json['clientId'];
    contentId = json['contentId'];
    createdAt = json['createdAt'];
    deviceType = json['deviceType'];
    eventLocation = json['eventLocation'];
    eventType = json['eventType'];
    id = json['id'];
    isCookieBlocked = json['isCookieBlocked'];
    mobileModel = json['mobileModel'];
    numOfCta = json['numOfCta'];
    osName = json['osName'];
    osVersion = json['osVersion'];
    paywallDisplayType = json['paywallDisplayType'];
    paywallId = json['paywallId'];
    paywallType = json['paywallType'];
    updatedAt = json['updatedAt'];
    url = json['url'];
    userAgent = json['userAgent'];
    userSourceData = json['userSourceData'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['anonId'] = this.anonId;
    data['browser'] = this.browser;
    data['browserVersion'] = this.browserVersion;
    data['clientId'] = this.clientId;
    data['contentId'] = this.contentId;
    data['createdAt'] = this.createdAt;
    data['deviceType'] = this.deviceType;
    data['eventLocation'] = this.eventLocation;
    data['eventType'] = this.eventType;
    data['id'] = this.id;
    data['isCookieBlocked'] = this.isCookieBlocked;
    data['mobileModel'] = this.mobileModel;
    data['numOfCta'] = this.numOfCta;
    data['osName'] = this.osName;
    data['osVersion'] = this.osVersion;
    data['paywallDisplayType'] = this.paywallDisplayType;
    data['paywallId'] = this.paywallId;
    data['paywallType'] = this.paywallType;
    data['updatedAt'] = this.updatedAt;
    data['url'] = this.url;
    data['userAgent'] = this.userAgent;
    data['userSourceData'] = this.userSourceData;
    return data;
  }
}
