// ignore_for_file: unused_import, duplicate_import

import 'dart:async';
import 'dart:convert';
import 'package:fk_user_agent/fk_user_agent.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:get/get.dart';
import 'package:http/http.dart' as http;
import 'package:intl/intl.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:uuid/uuid.dart';

import 'ConscentInitializer.dart';
import 'ConscentMethods.dart';
import 'Constants.dart';
import 'Model/APIMode.dart';
import 'Model/ContentDetails2.dart';
import 'Model/PageViewEvent.dart';
import 'Model/PaywallClickEvent.dart';
import 'Model/PaywallViewEvent.dart';
import 'Model/embeddedSubscribtion.dart';
import 'Model/loginChallengepost.dart';
import 'Model/subscriptionAccess.dart';
import 'SharedPref.dart';
import 'passesWebviews.dart';
import 'webview.dart';
import 'webviewConscent.dart';

var messageBodyData = MessageBody();
var messageBodyDataEvent = MessageBodyEvent();
ConscentMethods? conscentMethods;

class DefaultSub extends StatefulWidget {
  Function(String) sessionCallback;
  DefaultSub(this.sessionCallback, {Key? key}) : super(key: key);

  @override
  State<DefaultSub> createState() => _MyAppppState();
}

class _MyAppppState extends State<DefaultSub> {
  bool visible = false;

  final loginChallengeId = TextEditingController();
  final redirectTo = TextEditingController();

  final clientId = TextEditingController();
  final clientContentId = TextEditingController();
  final sessionId = TextEditingController();

  @override
  void initState() {
    super.initState();
    Constants.totalTime = 0;
    conscentMethods = ConscentMethods();

    getPsts();
  }

  @override
  void dispose() {
    super.dispose();
  }

  Future<void> paywallViewEvent() async {
    await ConscentMethods().getOSVersion();
    var anonId = await SharedPref().getAnonId();

    anonId ??=
        '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';
    await SharedPref().setAnonId(anonId);

    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");

    String createdAt = dateFormat.format(DateTime.now());

    messageBodyData.id =
        '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';
    messageBodyData.clientId = ConscentInitializer.mClientId;
    messageBodyData.contentId = ConscentInitializer.mContentId;
    messageBodyData.anonId = anonId;
    messageBodyData.createdAt = createdAt;
    messageBodyData.updatedAt = createdAt;
    messageBodyData.deviceType = "Mobile";
    messageBodyData.eventLocation = "PAYWALL";
    messageBodyData.eventType = "VIEW";
    messageBodyData.paywallDisplayType = "INARTICLE";
    messageBodyData.isCookieBlocked = 0;
    messageBodyData.paywallId = "Default";
    messageBodyData.numOfCta = Constants.numOfCta;

    messageBodyData.osVersion = Constants.osVersion;
    messageBodyData.mobileModel = Constants.mobileModel;
    messageBodyData.osName = Constants.osName;
    messageBodyData.userAgent = Constants.userAgent;

    var paywallViewEvent = PaywallViewEvent(messageBody: [messageBodyData]);
    paywallViewEvent.topic = "demoTopic";

    print("collections1 ${paywallViewEvent.messageBody}");
    print("collections1 ${paywallViewEvent.messageBody?.length.toString()}");

    print(messageBodyData.toJson());

    final headers = {'Content-Type': 'application/json'};
    Map<String, dynamic> body = paywallViewEvent.toJson();
    String jsonBody = json.encode(body);
    final encoding = Encoding.getByName('utf-8');
    print("utf  ${jsonBody}");
    var response = await http.post(
      Uri.parse('https://collections.tsbdev.co/collect/event'),
      headers: headers,
      body: jsonBody,
      encoding: encoding,
    );

    int? statusCode = response.statusCode;
    String responseBody = response.body;
    print("statusCode  ${statusCode.toString()}");
    print("responseBody  ${responseBody.toString()}");
  }

  //Click Event

  Future<void> paywallClickEvent(String clickAction) async {
    await ConscentMethods().getOSVersion();
    var anonId = await SharedPref().getAnonId();
    anonId ??=
        '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';
    DateFormat dateFormat = DateFormat("yyyy-MM-dd HH:mm:ss");
    String createdAt = dateFormat.format(DateTime.now());

    messageBodyDataEvent.id =
        '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}';
    messageBodyDataEvent.clientId = ConscentInitializer.mClientId;
    messageBodyDataEvent.contentId = ConscentInitializer.mContentId;
    messageBodyDataEvent.anonId = anonId;
    messageBodyDataEvent.createdAt = createdAt;
    messageBodyDataEvent.updatedAt = createdAt;
    messageBodyDataEvent.deviceType = "Mobile";
    messageBodyDataEvent.isCookieBlocked = 0;
    messageBodyDataEvent.paywallId = "Default";
    messageBodyDataEvent.paywallType = "Default";
    messageBodyDataEvent.paywallDisplayType = "INARTICLE";
    messageBodyDataEvent.numOfCta = Constants.numOfCta;
    messageBodyDataEvent.osVersion = Constants.osVersion;
    messageBodyDataEvent.mobileModel = Constants.mobileModel;
    messageBodyDataEvent.osName = Constants.osName;
    messageBodyDataEvent.userAgent = Constants.userAgent;
    messageBodyDataEvent.clickAction = clickAction;
    messageBodyDataEvent.eventLocation = "PAYWALL";
    messageBodyDataEvent.eventType = "CLICK";
    var paywallViewClickEvent =
        PaywallClickEvent(messageBody: [messageBodyDataEvent]);
    paywallViewClickEvent.topic = "demoTopic";
    print(messageBodyData.toJson());
    final headers = {'Content-Type': 'application/json'};
    Map<String, dynamic> body = paywallViewClickEvent.toJson();
    String jsonBody = json.encode(body);
    final encoding = Encoding.getByName('utf-8');
    print("utf  ${jsonBody}");
    var response = await http.post(
      Uri.parse('https://collections.tsbdev.co/collect/event'),
      headers: headers,
      body: jsonBody,
      encoding: encoding,
    );

    int? statusCode = response.statusCode;
    String responseBody = response.body;
    print("statusCode  ${statusCode.toString()}");
    print("responseBody  ${responseBody.toString()}");
  }

  Object? get filteredProducts => null;

  Future<LoginChallengepost> createLogInChallenge(
      String loginChallengeId, String redirectTo) async {
    var response = await http
        .post(Uri.parse('${APIMode.BASE_URL}api/v1/login-challenge'), body: {
      "loginChallengeId":
          '${DateTime.now().millisecondsSinceEpoch.toString()}${Uuid().v4()}',
      "redirectTo": redirectTo
    });
    print(response.body);
    if (response.statusCode == 201) {
      var responseString = response.body;
      String loginChallengeId =
          loginChallengepostFromJson(responseString).loginChallengeId;
      final prefs = await SharedPreferences.getInstance();
      print(loginChallengeId);
      await prefs.setString('loginID', loginChallengeId);
      print('dev login challange id');
      print(prefs.getString('loginID'));
      return loginChallengepostFromJson(responseString);
    } else {
      conscentMethods?.onPluginError(response.body);
      throw Exception('Failed to create album.');
    }
  }

  clearData() async {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    prefs.clear();
    print("Data Cleared");
  }

  tryAutoLogin() async {
    var any = await SharedPreferences.getInstance();
    if (!any.containsKey("loginChallengeId")) {
      return false;
    } else {
      return true;
    }
  }

// Webview
  Future<SubscriptionAccess> getPostss() async {
    var client = http.Client();
    var uri = Uri.parse('${APIMode.BASE_URL}api/v1/subscription/access?');
    var response = await client.get(uri);
    if (response.statusCode == 200) {
      var json = response.body;
      return subscriptionAccessFromJson(json);
    } else {
      conscentMethods?.onPluginError(response.body);
      throw Exception('Failed to create album.');
    }
  }

  //microPricing Api ----------------------------------------------------------------------------------------------------
  dynamic dataMain;
  getPsts() async {
    var url = Uri.parse(
        '${APIMode.BASE_URL}api/v1/content?clientContentId=${ConscentInitializer.mContentId}&clientId=${ConscentInitializer.mClientId}');
    var response = await http.get(url);
    if (response.statusCode == 200) {
      dataMain = jsonDecode(response.body);
      ContentDetails2 contentDetails2 =
          ContentDetails2.fromJson(json.decode(response.body));
      Constants.numOfCta = 1;
      if (contentDetails2.validPass != null) {
        Constants.numOfCta = Constants.numOfCta + 1;
      }
      bool subscriptionsExist = false;
      subscriptionsExist = contentDetails2.subscriptionsExist!;
      if (subscriptionsExist) {
        Constants.numOfCta = Constants.numOfCta + 1;
      }
      print("dataMain");
      print('ContentDetails  ${contentDetails2.toJson()}');
      var subscriptionUrl = dataMain["subscriptionUrl"];
      SharedPref().setSubsUrl(subscriptionUrl);
      print("dataMain");
      setState(() {});
    } else {
      conscentMethods?.onPluginError(response.body);
      throw Exception('Failed to load album');
    }
  }

//API logout post
  @override
  Widget build(BuildContext context) {
    paywallViewEvent();

    return SafeArea(
      child: Scaffold(
          body: Center(
        child: Card(
          child: SingleChildScrollView(
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                const ListTile(
                  tileColor: Color.fromRGBO(240, 240, 240, 1.0),
                  title: Text(
                    'Continue Reading ...',
                    textAlign: TextAlign.center,
                  ),
                ),

                ListTile(
                  title: Text(
                    dataMain == null
                        ? ""
                        : dataMain["paywallCustomization"]
                                ["micropaymentDisplaytext"]
                            .toString(),
                    //  _dataMain.paywallCustomization.micropaymentDisplaytext,
                    textAlign: TextAlign.center,
                  ),
                ),

                ListTile(
                  title: Text(
                    dataMain == null
                        ? ""
                        : "Pay " +
                            dataMain["currencySymbol"] +
                            dataMain["price"].toString() +
                            " to read now",
                    textAlign: TextAlign.center,
                    style: TextStyle(fontSize: 22, fontWeight: FontWeight.bold),
                  ),
                ),

                ElevatedButton(
                  //////////////
                  onPressed: () {
                    paywallClickEvent("BUY_NOW");
                    print('Dev');
                    createLogInChallenge(loginChallengeId.text, redirectTo.text)
                        .then((value) {
                      Navigator.push(
                        context,
                        MaterialPageRoute(
                            builder: (context) => const WebViewApp()),
                      ).then((value) {
                        if (value != null) {
                          dynamic response = value['response'];
                          widget.sessionCallback(response);
                        }
                      });
                    });
                  },

                  ////////

                  // child:
                  //   Colors.black,
                  style: ElevatedButton.styleFrom(
                    shape: const StadiumBorder(),
                    primary: Color.fromRGBO(245, 194, 203, 1.0),
                    minimumSize: Size(240, 50),
                  ),

                  child: Text('Read Now', style: TextStyle(fontSize: 20)),
                ),

                // Row(
                //   mainAxisAlignment: MainAxisAlignment.center,
                //   crossAxisAlignment: CrossAxisAlignment.center,
                //   children: [
                //     const Text("Pay with "),
                //     Image.asset(
                //       'conscentplugin/assets/ConsCent-Logo.png',
                //       height: 50,
                //       width: 80,
                //       //   opacity: const AlwaysStoppedAnimation<double>(0.5)
                //     )
                //   ],
                // ),

                Row(
                  mainAxisAlignment: MainAxisAlignment.center,
                  children: <Widget>[
                    const Text('Already Purchased?',
                        style: TextStyle(
                            fontSize: 16, fontWeight: FontWeight.bold)),
                    TextButton(
                      child: const Text(
                        'Log into Conscent',
                        style: TextStyle(
                            fontSize: 16,
                            color: Color.fromRGBO(245, 194, 203, 1.0)),
                      ),
                      onPressed: () {
                        //signup screen
                        // getPost();
                        Navigator.push(
                          context,
                          MaterialPageRoute(
                            builder: (context) => const WebViewApp(),
                            settings: const RouteSettings(
                              arguments: EmbeddedSubscribtion,
                            ),
                          ),
                        );
                      },
                    ),
                  ],
                ),

                const ListTile(
                  title: Text(
                    'Onces paid this story is free for 30 Days',
                    textAlign: TextAlign.center,
                  ),
                ),

                const ListTile(
                  title: Text(
                    '------------------  OR  ------------------',
                    textAlign: TextAlign.center,
                  ),
                ),

                //------------HIDE DATA FROM PASSES--------------------------------------------------

                Visibility(
                    visible: dataMain == null
                        ? false
                        : dataMain["validPass"] == null
                            ? false
                            : true,
                    child: Column(
                      children: [
                        ListTile(
                          title: Text(
                              dataMain != null && dataMain["validPass"] == null
                                  ? ''
                                  : ''),
                          subtitle: Text(
                            dataMain == null
                                ? ""
                                : "${dataMain["validPass"] == null ? 'No hrs' : dataMain["validPass"]['duration'] ?? 'No data'} - hrs unlimited access to premium content",
                            textAlign: TextAlign.center,
                            style: TextStyle(
                                fontSize: 16, fontWeight: FontWeight.bold),
                          ),
                        ),
                        ElevatedButton(
                          onPressed: () {
                            paywallClickEvent("PASS");
                            print('Dev');
                            createLogInChallenge(
                                    loginChallengeId.text, redirectTo.text)
                                .then((value) {
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                    builder: (context) =>
                                        const WebViewAppsss()),
                              ).then((value) {
                                if (value != null) {
                                  dynamic response = value['response'];
                                  widget.sessionCallback(response);
                                }
                              });
                            });
                          },
                          style: ElevatedButton.styleFrom(
                              minimumSize: Size(240, 50),
                              shape: const StadiumBorder(),
                              primary: Colors.white,
                              // onSurface: Colors.black,
                              side:
                                  BorderSide(width: 2.0, color: Colors.black)),
                          child: Text(
                              'Buy a pass for ₹ ${dataMain != null && dataMain["validPass"] != null ? dataMain["validPass"]["price"].toString() : ""}',
                              style: TextStyle(
                                  fontSize: 20,
                                  color: Colors.black,
                                  fontWeight: FontWeight.bold)),
                        ),
                        // Row(
                        //   mainAxisAlignment: MainAxisAlignment.center,
                        //   crossAxisAlignment: CrossAxisAlignment.center,
                        //   children: [
                        //     const Text("Pay with "),
                        //     Image.asset(
                        //       'conscentplugin/assets/ConsCent-Logo.png',
                        //       height: 50,
                        //       width: 80,
                        //       //  opacity: const AlwaysStoppedAnimation<double>(0.5)
                        //     )
                        //   ],
                        // ),
                        const ListTile(
                          title: const Text(
                            '------------------  OR  ------------------',
                            textAlign: TextAlign.center,
                          ),
                        ),
                      ],
                    )),

                Visibility(
                    visible: dataMain == null
                        ? false
                        : dataMain["subscriptionsExist"] == false
                            ? false
                            : true,
                    child: Column(
                      children: [
                        ListTile(
                          title: Text(dataMain != null &&
                                  dataMain["subscriptionsExist"] == false
                              ? ''
                              : ''),
                          subtitle: Text(
                            dataMain == null
                                ? ""
                                : "${dataMain["subscriptionsExist"] == false ? 'No hrs' : dataMain["paywallCustomization"]['subscriptionTitle'] ?? 'No data'} ",
                            textAlign: TextAlign.center,
                            style: TextStyle(
                                fontSize: 16,
                                fontWeight: FontWeight.bold,
                                color: Colors.black),
                          ),
                        ),
                        ListTile(
                          title: Text(
                            dataMain == null
                                ? ""
                                : dataMain["paywallCustomization"]
                                    ["subscriptionText"],
                            textAlign: TextAlign.center,
                          ),
                        ),
                        ElevatedButton(
                          onPressed: () {
                            paywallClickEvent("SUBS");
                            print('Dev');
                            createLogInChallenge(
                                    loginChallengeId.text, redirectTo.text)
                                .then((value) {
                              Navigator.push(
                                context,
                                MaterialPageRoute(
                                    builder: (context) => const WebViewAppss()),
                              ).then((value) {
                                if (value != null) {
                                  dynamic response = value['response'];
                                  widget.sessionCallback(response);
                                }
                              });
                            });
                          },

                          child: const Text('Subscribe Now',
                              style: TextStyle(
                                  fontSize: 16,
                                  fontWeight: FontWeight.bold,
                                  color: Color.fromRGBO(245, 194, 203, 1.0))),

                          // style: ElevatedButton.styleFrom(
                          //   shape: const StadiumBorder(),
                          // ),
                          style: ElevatedButton.styleFrom(
                              minimumSize: Size(240, 50),
                              shape: const StadiumBorder(),
                              primary: Colors.white,
                              // onSurface: Colors.black,
                              side: BorderSide(
                                  width: 2.0,
                                  color: Color.fromRGBO(245, 194, 203, 1.0))),
                        ),
                        Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: <Widget>[
                            const Text('Already a Subscriber?',
                                style: TextStyle(
                                    fontSize: 15,
                                    color: Colors.black,
                                    fontWeight: FontWeight.bold)),
                            TextButton(
                              child: const Text(
                                'Sign In',
                                style: TextStyle(
                                    fontSize: 15,
                                    color: Color.fromRGBO(245, 194, 203, 1.0)),
                              ),
                              onPressed: () {},
                            ),
                          ],
                        ),
                      ],
                    )),
              ],
            ),
          ),
        ),
      )),
    );
  }
}
